
from lib import *
from model import *

from sentence_transformers import SentenceTransformer

if __name__=='__main__':
    model = Model().cuda()
    model.load_state_dict(T.load('./_saved/model.pt'))
    model.eval()
    bert = SentenceTransformer('stsb-roberta-large')
    os.environ['TOKENIZERS_PARALLELISM'] = 'true'

    img = ['./_input/lion.jpg', './_input/lion.jpg']
    ins = ['veined, bumpy, green, shiny, moist', 'veined, bumpy, orange, shiny, moist']
    for i, (img, ins) in enumerate(zip(img, ins)):
        img = TV.transforms.ToTensor()(Image.open(img)).unsqueeze(0)
        ins = T.from_numpy(bert.encode([ins]))
        hid_con, _ = model.forward_enc(img.cuda())
        feat_ins = model.i2f(ins.cuda())
        out = model.forward_dec(feat_ins, hid_con)
        
        out = out.permute(0, 2, 3, 1).data.cpu().numpy()
        o = (out[0]*255).astype('uint8')
        Image.fromarray(o).save('./_output/%d.jpg'%(i))
